import { Container, Token } from 'ditox';
import { Controller } from './controller';
import { Scope } from './scope';
import { AnyObject } from './utils';
export declare function createController<Service extends AnyObject>(factory: (scope: Scope) => Service & {
    destroy?: () => void;
}): Controller<Service>;
export type ControllerFactory<Service extends AnyObject> = (container: Container) => Controller<Service>;
export type InferredService<Factory> = Factory extends ControllerFactory<infer Service> ? Service : never;
declare type DependencyProps = {
    [key: string]: unknown;
};
declare type TokenProps<Props extends DependencyProps> = {
    [K in keyof Props]: Token<Props[K]>;
};
export declare function declareController<Dependencies extends DependencyProps, Service extends AnyObject>(tokens: TokenProps<Dependencies>, factory: (deps: Dependencies, scope: Scope) => Service): ControllerFactory<Service>;
export type ViewControllerFactory<Service extends AnyObject, Params extends unknown[]> = (container: Container, ...params: Params) => Controller<Service>;
export declare function declareViewController<Service extends AnyObject, Params extends unknown[]>(factory: (scope: Scope, ...params: Params) => Service): ViewControllerFactory<Service, Params>;
export declare function declareViewController<Dependencies extends DependencyProps, Service extends AnyObject, Params extends unknown[]>(tokens: TokenProps<Dependencies>, factory: (deps: Dependencies, scope: Scope) => ((scope: Scope, ...params: Params) => Service) | Service): ViewControllerFactory<Service, Params>;
export {};
